// Plugin.h: interface for the CPlugin class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_KHW_PLUGIN_H__7CED3CE1_4860_11D5_AAD6_0002B322E676__INCLUDED_)
#define AFX_KHW_PLUGIN_H__7CED3CE1_4860_11D5_AAD6_0002B322E676__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

typedef struct
{
	double    m_dVersion;
	HWND      m_wndParent;
	void     *m_pData;
	int       m_iDataLen;
	char      m_szDisplayString[256];
} KHW_PLUGIN_DATA;

typedef struct
{
	double m_dVersion;
	int    m_iID;
	char   m_szName[256];
	char   m_szCheckName[256];
	char   m_szPropertiesTabTitle[256];
	char   m_szPreferencesTabTitle[256];
} KHW_PLUGIN_INFO;

typedef struct
{
	double    m_dVersion;
	void     *m_pData;
	int       m_iDataLen;
	char     *m_szMessage;
	int       m_iOldServerState;
	int       m_iNewServerState;
} KHW_PLUGIN_ACTION_DATA;

typedef struct
{
	double    m_dVersion;
	void     *m_pData;
	int       m_iDataLen;
	char     *m_szError;
	int      *m_pbInterrupted;
} KHW_PLUGIN_CHECK_DATA;

typedef void (PASCAL __stdcall *CBeginEditProperties) (KHW_PLUGIN_DATA *pPluginData);
typedef void (PASCAL __stdcall *CGetProperties) (KHW_PLUGIN_DATA *pPluginData);
typedef void (PASCAL __stdcall *CEndEditProperties) (void);

typedef void (PASCAL __stdcall *CBeginEditPreferences) (HWND hwndParent);
typedef void (PASCAL __stdcall *CEndEditPreferences) (void);
typedef void (PASCAL __stdcall *CSavePreferences) (void);

typedef int  (PASCAL __stdcall *CCheckServer) (KHW_PLUGIN_CHECK_DATA *pData);
typedef int  (PASCAL __stdcall *CDoAction) (KHW_PLUGIN_ACTION_DATA *pData);
typedef void (PASCAL __stdcall *CGetInfo) (KHW_PLUGIN_INFO *pPluginInfo);
typedef void (PASCAL __stdcall *CReleaseMemory) (void *pMemory, int iSize);

#endif // !defined(AFX_KHW_PLUGIN_H__7CED3CE1_4860_11D5_AAD6_0002B322E676__INCLUDED_)
